"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AntdListControlProperties = AntdListControlProperties;
exports.default = void 0;

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.object.set-prototype-of");

require("antd-mobile/es/list/style");

var _list = _interopRequireDefault(require("antd-mobile/es/list"));

require("core-js/modules/es6.regexp.search");

var _react = _interopRequireDefault(require("react"));

var _Control2 = _interopRequireDefault(require("../Control"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var AntdListControl =
/*#__PURE__*/
function (_Control) {
  _inherits(AntdListControl, _Control);

  function AntdListControl(props, context) {
    var _this;

    _classCallCheck(this, AntdListControl);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(AntdListControl).call(this, props, context));
    _this.state = {
      type: 'antdList'
    };
    return _this;
  }

  _createClass(AntdListControl, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var search = this.props.search;

      if (search) {
        search();
      }
    }
  }, {
    key: "renderControl",
    value: function renderControl() {
      var _this$props = this.props,
          header = _this$props.header,
          content = _this$props.content,
          items = _this$props.items;
      var listOptions = {};

      if (header != null && header != '') {
        listOptions.renderHeader = function () {
          return header;
        };
      }

      return _react.default.createElement(_list.default, listOptions, content);
    }
  }]);

  return AntdListControl;
}(_Control2.default);

exports.default = AntdListControl;

function AntdListControlProperties(controlId, bindedFieldOptions) {
  return [{
    key: 'id',
    title: '控件ID',
    value: controlId,
    type: 'text',
    disabled: true,
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'headerRender',
    title: '标题',
    value: '',
    type: 'codeModal',
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'items',
    title: '子项',
    value: [],
    type: 'listItems',
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'searchEvent',
    title: '查询事件',
    value: '',
    type: 'code',
    layout: {
      labelCol: {
        span: -1
      },
      wrapperCol: {
        span: 24
      }
    }
  }];
}