"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BpmTableControlProperties = BpmTableControlProperties;
exports.default = void 0;

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.object.set-prototype-of");

require("antd-mobile/es/modal/style");

var _modal = _interopRequireDefault(require("antd-mobile/es/modal"));

require("antd-mobile/es/list/style");

var _list = _interopRequireDefault(require("antd-mobile/es/list"));

require("core-js/modules/es6.function.name");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

require("regenerator-runtime/runtime");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.regexp.search");

require("antd-mobile/es/steps/style");

var _steps = _interopRequireDefault(require("antd-mobile/es/steps"));

var _react = _interopRequireDefault(require("react"));

var _Control2 = _interopRequireDefault(require("../Control"));

var _service = require("../../../service");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Step = _steps.default.Step;

var BpmTableControl =
/*#__PURE__*/
function (_Control) {
  _inherits(BpmTableControl, _Control);

  function BpmTableControl(props, context) {
    var _this;

    _classCallCheck(this, BpmTableControl);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(BpmTableControl).call(this, props, context));
    _this.state = {
      type: 'bpmTable',
      processList: [],
      loading: false,
      selectProcess: null,
      imgVisible: false,
      recordVisible: false,
      processApproveDetails: []
    };
    return _this;
  }

  _createClass(BpmTableControl, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.designmode != 'true') {
        this.search();
      }
    }
  }, {
    key: "search",
    value: function search() {
      var _this2 = this;

      var _this$props = this.props,
          processKey = _this$props.processKey,
          code = _this$props.code;
      return new Promise(
      /*#__PURE__*/
      function () {
        var _ref = _asyncToGenerator(
        /*#__PURE__*/
        _regenerator.default.mark(function _callee(resolve) {
          var params, rtnData;
          return _regenerator.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  params = {
                    url: '/bpm/process/getProcessByCode',
                    params: {
                      process_key: processKey,
                      code: code
                    }
                  };
                  _context.next = 3;
                  return (0, _service.post)(params);

                case 3:
                  rtnData = _context.sent;

                  if (rtnData != null && rtnData.err == null) {
                    _this2.setState({
                      processList: rtnData,
                      loading: false
                    });
                  }

                  resolve('success');

                case 6:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));

        return function (_x) {
          return _ref.apply(this, arguments);
        };
      }());
    }
  }, {
    key: "searchProcessHistory",
    value: function searchProcessHistory(record) {
      return new Promise(
      /*#__PURE__*/
      function () {
        var _ref2 = _asyncToGenerator(
        /*#__PURE__*/
        _regenerator.default.mark(function _callee2(resolve) {
          var params;
          return _regenerator.default.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  params = {
                    url: '/bpm/process/getApproveHistory',
                    params: {
                      process_id: record.processId
                    }
                  };
                  _context2.t0 = resolve;
                  _context2.next = 4;
                  return (0, _service.post)(params);

                case 4:
                  _context2.t1 = _context2.sent;
                  (0, _context2.t0)(_context2.t1);

                case 6:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2, this);
        }));

        return function (_x2) {
          return _ref2.apply(this, arguments);
        };
      }());
    }
  }, {
    key: "renderControl",
    value: function renderControl() {
      var _this3 = this;

      var _this$state = this.state,
          processList = _this$state.processList,
          recordVisible = _this$state.recordVisible,
          processApproveDetails = _this$state.processApproveDetails;
      var currentStep = 0;
      var steps = [];

      if (processApproveDetails.length > 0) {
        steps.push(_react.default.createElement(Step, {
          key: "0",
          status: "finished",
          title: processApproveDetails[0].processStartUserName,
          description: _react.default.createElement("div", null, _react.default.createElement("div", null, "\u5DF2\u63D0\u4EA4"), _react.default.createElement("div", null, processApproveDetails[0].processStartTime))
        }));
      }

      for (var i = 0; i < processApproveDetails.length; i += 1) {
        var item = processApproveDetails[i];
        var isPass = item.isPass;
        var isPassStr = '';

        if (isPass && isPass !== '') {
          isPassStr = '同意';
        } else if (!isPass && isPass !== '') {
          isPassStr = '不同意';
        } else {
          isPassStr = '未开始';
        }

        var status = 'process';

        if (isPassStr == '' && item.startTime == '未开始') {
          status = 'process';
          currentStep = i + 1;
        } else if (isPassStr == '同意') {
          status = 'finished';
        } else if (isPassStr == '不同意') {
          status = 'error';
        }

        steps.push(_react.default.createElement(Step, {
          key: item.name,
          status: status,
          title: item.auditUserName,
          description: _react.default.createElement("div", null, _react.default.createElement("div", null, isPassStr), isPassStr != '未开始' ? _react.default.createElement("div", null, "\u6279\u6CE8\uFF1A", item.comment) : '', _react.default.createElement("div", null, item.endTime))
        }));
      }

      return _react.default.createElement("div", null, _react.default.createElement(_list.default, null, processList.map(function (item) {
        return _react.default.createElement(_list.default.Item, {
          key: item.processId,
          arrow: "horizontal",
          onClick: function onClick() {
            _this3.searchProcessHistory(item).then(function (data) {
              _this3.setState({
                processApproveDetails: data,
                recordVisible: true,
                selectProcess: item
              });
            });
          }
        }, "\u5DE5\u4F5C\u6D41ID: ", item.processId, _react.default.createElement("br", null), "\u5DE5\u4F5C\u6D41\u540D\u79F0: ", item.processName, _react.default.createElement("br", null), "\u53D1\u8D77\u65F6\u95F4: ", item.processStartTime, _react.default.createElement("br", null), "\u72B6\u6001: ", item.processIsSuspended ? '完结' : '进行中', _react.default.createElement("br", null));
      })), _react.default.createElement(_modal.default, {
        title: "\u5BA1\u6279\u8BB0\u5F55",
        transparent: true,
        closable: true,
        visible: recordVisible,
        style: {
          width: '100%'
        },
        onClose: function onClose() {
          _this3.setState({
            recordVisible: false,
            selectProcess: {},
            processApproveDetails: []
          });
        }
      }, _react.default.createElement(_list.default, null, _react.default.createElement("div", {
        style: {
          textAlign: 'left',
          marginLeft: '30%'
        }
      }, _react.default.createElement(_steps.default, {
        current: currentStep
      }, steps)))));
    }
  }]);

  return BpmTableControl;
}(_Control2.default);

exports.default = BpmTableControl;

function BpmTableControlProperties(controlId, bindedFieldOptions) {
  return [{
    key: 'id',
    title: '控件ID',
    value: controlId,
    type: 'text',
    disabled: true,
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'codeField',
    title: '编码字段',
    value: '',
    type: 'select',
    options: bindedFieldOptions,
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }];
}