"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CommonDetailControlProperties = CommonDetailControlProperties;
exports.default = void 0;

require("core-js/modules/es6.object.assign");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("antd-mobile/es/modal/style");

var _modal = _interopRequireDefault(require("antd-mobile/es/modal"));

require("antd-mobile/es/button/style");

var _button = _interopRequireDefault(require("antd-mobile/es/button"));

require("antd-mobile/es/nav-bar/style");

var _navBar = _interopRequireDefault(require("antd-mobile/es/nav-bar"));

require("antd-mobile/es/icon/style");

var _icon = _interopRequireDefault(require("antd-mobile/es/icon"));

require("core-js/modules/es6.regexp.match");

require("antd-mobile/es/popover/style");

var _popover = _interopRequireDefault(require("antd-mobile/es/popover"));

require("core-js/modules/es6.function.name");

require("core-js/modules/es6.array.find");

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.object.set-prototype-of");

require("antd-mobile/es/list/style");

var _list = _interopRequireDefault(require("antd-mobile/es/list"));

var _react = _interopRequireDefault(require("react"));

var _moment = _interopRequireDefault(require("moment"));

var _Control2 = _interopRequireDefault(require("../Control"));

var _ControlFactory = _interopRequireDefault(require("./ControlFactory"));

var _dictUtil = _interopRequireDefault(require("../../../dictUtil"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var CommonDetailControl =
/*#__PURE__*/
function (_Control) {
  _inherits(CommonDetailControl, _Control);

  function CommonDetailControl(props, context) {
    var _this;

    _classCallCheck(this, CommonDetailControl);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(CommonDetailControl).call(this, props, context));
    _this.state = {
      type: 'commonDetail'
    };
    return _this;
  }

  _createClass(CommonDetailControl, [{
    key: "renderControl",
    value: function renderControl() {
      var _this$props = this.props,
          detailFormVisible = _this$props.detailFormVisible,
          dict = _this$props.dict,
          post = _this$props.post,
          dispatch = _this$props.dispatch,
          history = _this$props.history,
          detailFormData = _this$props.detailFormData,
          updateDetailData = _this$props.updateDetailData,
          closeDetailForm = _this$props.closeDetailForm,
          setFormValues = _this$props.setFormValues,
          buttons = _this$props.buttons,
          columns = _this$props.columns,
          detailData = _this$props.detailData,
          itemRender = _this$props.itemRender,
          antdMobile = _this$props.antdMobile,
          formData = _this$props.formData,
          operationType = _this$props.operationType,
          pageId = _this$props.pageId;
      return _react.default.createElement("div", null, _react.default.createElement(_list.default, {
        style: {
          minHeight: '20px'
        }
      }, itemRender(detailData)), detailFormVisible ? _react.default.createElement(DetailForm, {
        dict: dict,
        dispatch: dispatch,
        history: history,
        antdMobile: antdMobile,
        visible: detailFormVisible,
        detailFormData: detailFormData,
        pageId: pageId,
        buttons: buttons,
        columns: columns,
        formData: formData,
        post: post,
        detailData: detailData,
        operationType: operationType,
        setFormValues: setFormValues,
        closeDetailForm: closeDetailForm,
        updateDetailData: updateDetailData
      }) : '');
    }
  }]);

  return CommonDetailControl;
}(_Control2.default);

exports.default = CommonDetailControl;

var DetailForm =
/*#__PURE__*/
function (_React$Component) {
  _inherits(DetailForm, _React$Component);

  function DetailForm(props, context) {
    var _this2;

    _classCallCheck(this, DetailForm);

    _this2 = _possibleConstructorReturn(this, _getPrototypeOf(DetailForm).call(this, props, context));
    _this2.state = {
      toolbarVisible: false
    };
    return _this2;
  }

  _createClass(DetailForm, [{
    key: "getPropertiesJson",
    value: function getPropertiesJson(properties) {
      var json = {};

      for (var i = 0; i < properties.length; i += 1) {
        var property = properties[i];
        json[property.key] = property.value;
      }

      return json;
    }
  }, {
    key: "renderComponents",
    value: function renderComponents() {
      var _this3 = this;

      var _this$props2 = this.props,
          detailFormData = _this$props2.detailFormData,
          updateDetailData = _this$props2.updateDetailData,
          detailData = _this$props2.detailData,
          formData = _this$props2.formData,
          setFormValues = _this$props2.setFormValues,
          columns = _this$props2.columns,
          antdMobile = _this$props2.antdMobile,
          pageId = _this$props2.pageId,
          operationType = _this$props2.operationType;
      var data = detailData.find(function (item) {
        return item.f_id == detailFormData.f_id;
      });
      var controls = [];

      for (var i = 0; i < columns.length; i += 1) {
        var component = columns[i];
        var id = component.id,
            type = component.type,
            independent = component.independent,
            components = component.components,
            properties = component.properties;
        var propertiesJson = this.getPropertiesJson(properties);

        var ColumnControl = _ControlFactory.default.getControl(type);

        var options = {
          pageId: pageId
        };
        var style = propertiesJson.style,
            isVisible = propertiesJson.isVisible;

        if (isVisible != null && isVisible != '') {
          var event = new Function('formData', 'record', isVisible).bind(this);
          var visible = event(formData, data);

          if (visible == false) {
            continue;
          }
        }

        if (style != null && style != '') {
          var _event = new Function(style).bind(this);

          options.style = _objectSpread({}, _event());
        }

        if (type != 'grid' && type != 'list' && type != 'navBar') {
          (function () {
            options.setFormValues = setFormValues;
            var bindField = propertiesJson.bindField,
                onChangeEvent = propertiesJson.onChangeEvent;

            if (bindField != null && bindField != '') {
              options.value = data[bindField];
            }

            options.formData = data;

            var onChange = function onChange(val, rowData) {
              data[bindField] = val;

              if (data.flag == null) {
                data.flag = 'U';
              }

              if (onChangeEvent != null && onChangeEvent !== '') {
                var code = Babel.transform(onChangeEvent, {
                  presets: [require('@babel/preset-react')],
                  parserOpts: {
                    allowReturnOutsideFunction: true
                  }
                }).code;

                var _event2 = new Function('value', 'record', 'rowData', 'detailData', 'setFormValues', 'AntdMobile', 'moment', code).bind(_this3);

                _event2(val, data, rowData, detailData, setFormValues, antdMobile, _moment.default);
              }

              updateDetailData(data);

              _this3.forceUpdate();
            };

            options.onChange = onChange.bind(_this3);
            options.operationType = operationType;
          })();
        }

        if (type == 'picker') {
          var dictCode = propertiesJson.dictCode,
              dataFilterEvent = propertiesJson.dataFilterEvent;

          if (dictCode != null && dictCode != '') {
            var dict = this.props.dict;
            propertiesJson.options = (0, _dictUtil.default)(dict[dictCode]);
          }

          if (dataFilterEvent != null && dataFilterEvent != '') {
            (function () {
              var event = new Function('options', dataFilterEvent).bind(_this3);

              propertiesJson.dataFilter = function (ops) {
                return event(ops);
              };
            })();
          }
        }

        if (type == 'searchPicker') {
          var queryConfig = propertiesJson.queryConfig;
          var queryConfigFn = new Function('formData', 'record', "return ".concat(queryConfig)).bind(this);
          options.queryConfig = queryConfigFn(formData, data);
        }

        if (propertiesJson.onClickEvent != null && propertiesJson.onClickEvent !== '') {
          (function () {
            var event = new Function('formData', 'record', 'AntdMobile', "".concat(propertiesJson.onClickEvent)).bind(_this3);

            options.onClick = function () {
              event(formData, data, antdMobile);
            };
          })();
        }

        if (propertiesJson.isEnabled != null && propertiesJson.isEnabled !== '') {
          var _event3 = new Function('formData', 'record', 'AntdMobile', "".concat(propertiesJson.isEnabled)).bind(this);

          options.disabled = !_event3(formData, data, antdMobile);
        }

        controls.push(_react.default.createElement(ColumnControl, _extends({
          key: id,
          id: id,
          designmode: "false",
          independent: independent,
          selected: false
        }, propertiesJson, options)));
      }

      return controls;
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var _this$props3 = this.props,
          detailFormData = _this$props3.detailFormData,
          visible = _this$props3.visible,
          buttons = _this$props3.buttons,
          closeDetailForm = _this$props3.closeDetailForm;
      var overlay = [];

      for (var i = 0; i < buttons.length; i += 1) {
        var button = buttons[i];
        var options = {};
        options.key = button.key;
        options.name = button.name;

        if (button.isVisible) {
          var v = button.isVisible();

          if (!v) {
            continue;
          }
        }

        overlay.push(_react.default.createElement(_popover.default.Item, options, button.name));
      }

      var ua = navigator.userAgent;
      var isIOS = !!ua.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/);
      var isAndroid = ua.indexOf('Android') > -1 || ua.indexOf('Adr') > -1;
      var paddingTop = 10;

      if (isIOS || isAndroid) {
        paddingTop = 40;
      }

      var rightContent = null;

      if (overlay.length > 0) {
        rightContent = _react.default.createElement(_popover.default, {
          overlayStyle: {
            color: 'currentColor',
            transform: 'translateZ(1000px)'
          },
          visible: this.state.visible,
          overlay: overlay,
          align: {
            overflow: {
              adjustY: 0,
              adjustX: 0
            },
            offset: [-10, 0]
          },
          onVisibleChange: function onVisibleChange(v) {
            return _this4.setState({
              toolbarVisible: v
            });
          },
          onSelect: function onSelect(opt) {
            var key = opt.key;
            var button = buttons.find(function (item) {
              return item.key == key;
            });

            if (button.onClick) {
              button.onClick(detailFormData);

              _this4.setState({
                toolbarVisible: false
              });
            }
          }
        }, _react.default.createElement("div", {
          style: {
            height: '100%',
            padding: '0 15px',
            marginRight: '-15px',
            display: 'flex',
            alignItems: 'center'
          }
        }, _react.default.createElement(_icon.default, {
          type: "ellipsis"
        })));
      }

      return _react.default.createElement(_modal.default, {
        title: null,
        popup: true,
        visible: visible,
        onClose: function onClose() {
          return _this4.clear();
        },
        animationType: "slide-up",
        style: {
          height: '100%'
        },
        bodyStyle: {
          display: 'flex',
          flexDirection: 'column',
          height: "calc(100% - ".concat(paddingTop, "px)"),
          paddingTop: "".concat(paddingTop, "px"),
          zIndex: 1
        }
      }, _react.default.createElement(_navBar.default, {
        mode: "light",
        rightContent: rightContent
      }, "\u660E\u7EC6\u8BE6\u60C5"), _react.default.createElement("div", {
        style: {
          paddingTop: 0,
          flex: 1,
          height: '100%',
          overflow: 'auto',
          backgroundColor: 'white'
        }
      }, this.renderComponents()), _react.default.createElement(_button.default, {
        type: "warning",
        onClick: function onClick() {
          return closeDetailForm();
        }
      }, "\u5173\u95ED"));
    }
  }]);

  return DetailForm;
}(_react.default.Component);

function CommonDetailControlProperties(controlId, bindedFieldOptions) {
  return [{
    key: 'id',
    title: '控件ID',
    value: controlId,
    type: 'text',
    disabled: true,
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'bindField',
    title: '绑定字段',
    value: '',
    type: 'select',
    options: bindedFieldOptions,
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'buttons',
    title: '按钮',
    value: [],
    type: 'buttons',
    layout: {
      labelCol: {
        span: 5
      },
      wrapperCol: {
        span: 19
      }
    }
  }, {
    key: 'columns',
    title: '列集合',
    value: [],
    type: 'commonDetailColumns',
    layout: {
      labelCol: {
        span: 5
      },
      wrapperCol: {
        span: 19
      }
    }
  }, {
    key: 'itemRender',
    title: '列表渲染',
    value: '',
    type: 'codeModal',
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }];
}