"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ContainerControlProperties = ContainerControlProperties;
exports.default = void 0;

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.object.set-prototype-of");

var _react = _interopRequireDefault(require("react"));

var _Control2 = _interopRequireDefault(require("../Control"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var ContainerControl =
/*#__PURE__*/
function (_Control) {
  _inherits(ContainerControl, _Control);

  function ContainerControl(props, context) {
    var _this;

    _classCallCheck(this, ContainerControl);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ContainerControl).call(this, props, context));
    _this.state = {
      type: 'container'
    };
    return _this;
  }

  _createClass(ContainerControl, [{
    key: "getControlStyle",
    value: function getControlStyle() {
      var designmode = this.props.designmode;
      var style = {};

      if (designmode == 'true') {
        style['paddingBottom'] = '20px';
      }

      return style;
    }
  }, {
    key: "renderControl",
    value: function renderControl() {
      return this.props.children; // const { id, designmode, children, onDragOver, onDragStart, onDrop, style } = this.props;
      // const newStyle = {
      //   ...style,
      // };
      // if (designmode == 'true') {
      //   newStyle['paddingBottom'] = '20px';
      // }
      // return (
      //   <div
      //     id={id}
      //     onDragOver={onDragOver}
      //     onDragStart={onDragStart}
      //     onDrop={onDrop}
      //     style={newStyle}
      //   >
      //     {children}
      //   </div>
      // );
    }
  }]);

  return ContainerControl;
}(_Control2.default);

exports.default = ContainerControl;

function ContainerControlProperties(controlId, bindedFieldOptions) {
  return [{
    key: 'id',
    title: '控件ID',
    value: controlId,
    type: 'text',
    disabled: true,
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'style',
    title: '样式',
    value: '',
    type: 'codeModal',
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }];
}