"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NavBarControlProperties = NavBarControlProperties;
exports.default = void 0;

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.object.set-prototype-of");

require("antd-mobile/es/nav-bar/style");

var _navBar = _interopRequireDefault(require("antd-mobile/es/nav-bar"));

var _react = _interopRequireDefault(require("react"));

var _Control2 = _interopRequireDefault(require("../Control"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var NavBarControl =
/*#__PURE__*/
function (_Control) {
  _inherits(NavBarControl, _Control);

  function NavBarControl(props, context) {
    var _this;

    _classCallCheck(this, NavBarControl);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(NavBarControl).call(this, props, context));
    _this.state = {
      type: 'navBar'
    };
    return _this;
  }

  _createClass(NavBarControl, [{
    key: "renderControl",
    value: function renderControl() {
      var _this$props = this.props,
          mode = _this$props.mode,
          title = _this$props.title,
          icon = _this$props.icon,
          _onLeftClick = _this$props.onLeftClick,
          rightContent = _this$props.rightContent;
      return _react.default.createElement(_navBar.default, {
        mode: mode,
        icon: icon,
        onLeftClick: function onLeftClick() {
          if (_onLeftClick) {
            _onLeftClick();
          }
        },
        rightContent: rightContent
      }, title);
    }
  }]);

  return NavBarControl;
}(_Control2.default);

exports.default = NavBarControl;

function NavBarControlProperties(controlId) {
  return [{
    key: 'id',
    title: '控件ID',
    value: controlId,
    type: 'text',
    disabled: true,
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'style',
    title: '样式',
    value: '',
    type: 'codeModal',
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'mode',
    title: 'mode',
    value: 'light',
    type: 'select',
    options: [{
      value: 'light',
      label: 'light'
    }, {
      value: 'dark',
      label: 'dark'
    }],
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'title',
    title: '标题',
    value: '',
    type: 'codeModal',
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'icon',
    title: '左图标',
    value: '',
    type: 'codeModal',
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'onLeftClick',
    title: '左边点击事件',
    value: '',
    type: 'code',
    layout: {
      labelCol: {
        span: -1
      },
      wrapperCol: {
        span: 24
      }
    }
  }, {
    key: 'rightContent',
    title: '右边内容',
    value: '',
    type: 'codeModal',
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }];
}