"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es6.object.assign");

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.object.set-prototype-of");

require("core-js/modules/es6.function.name");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

require("regenerator-runtime/runtime");

require("core-js/modules/es6.array.find");

require("antd-mobile/es/modal/style");

var _modal = _interopRequireDefault(require("antd-mobile/es/modal"));

require("core-js/modules/es6.promise");

require("core-js/modules/es6.regexp.replace");

require("antd-mobile/es/toast/style");

var _toast = _interopRequireDefault(require("antd-mobile/es/toast"));

require("core-js/modules/es6.regexp.match");

var _react = _interopRequireDefault(require("react"));

var _dva = require("dva");

var _fetch = _interopRequireDefault(require("dva/fetch"));

var _moment = _interopRequireDefault(require("moment"));

var _ControlFactory = _interopRequireDefault(require("./Controls/mobile/ControlFactory"));

var _dictUtil = _interopRequireWildcard(require("../dictUtil"));

var _service = require("../service");

require("./pagedetail.css");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var antdMobile = require('antd-mobile');

var PageDetail =
/*#__PURE__*/
function (_React$Component) {
  _inherits(PageDetail, _React$Component);

  function PageDetail(props, context) {
    var _this;

    _classCallCheck(this, PageDetail);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(PageDetail).call(this, props, context));
    _this.pageId = _this.props.match.params.pageId;
    _this.moment = _moment.default;
    _this.dictUtil = _dictUtil.default;
    _this.getDictName = _dictUtil.getDictName;
    _this.state = {};
    return _this;
  }

  _createClass(PageDetail, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.loadDesign();
      this.loadDict();
    } // shouldComponentUpdate(nextProps, nextState, nextContext) {
    //   // console.log(this.props.page, nextProps.page);
    //   if (JSON.stringify(nextProps) === JSON.stringify(this.props)) {
    //     return false;
    //   }
    //   return true;
    // }

  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      var _this$props = this.props,
          loading = _this$props.loading,
          match = _this$props.match,
          page = _this$props.page;
      var pageId = match.params.pageId;

      if (prevProps.loading != loading) {
        if (loading) {
          _toast.default.loading('加载中...', 0);
        } else {
          _toast.default.hide();
        }
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var pageState = this.props.page[this.pageId];

      if (pageState != null && pageState.isClearState == '1') {
        this.props.dispatch({
          type: 'page/clearPageState',
          payload: {
            pageId: this.pageId
          }
        });
      }
    }
  }, {
    key: "setFormValues",
    value: function setFormValues(values) {
      this.props.dispatch({
        type: 'page/setFormValues',
        payload: {
          pageId: this.pageId,
          values: values
        }
      });
    }
  }, {
    key: "getPropertiesJson",
    value: function getPropertiesJson(properties) {
      var json = {};

      for (var i = 0; i < properties.length; i += 1) {
        var property = properties[i];
        json[property.key] = property.value;
      }

      return json;
    }
  }, {
    key: "edit",
    value: function edit() {
      this.props.dispatch({
        type: 'page/stateChange',
        payload: {
          pageId: this.pageId,
          params: {
            operationType: 'E',
            editEnable: true
          }
        }
      });
    }
  }, {
    key: "get",
    value: function get(params) {
      var requestProject = this.props.requestProject;
      var bindedEntity = this.props.page[this.pageId].bindedEntity;
      var table_name = bindedEntity.table_name;
      var method = table_name.replace('_', '.') + '.get';
      var url = "/".concat(requestProject, "/rest?com_id=0&method=").concat(method);
      this.props.dispatch({
        type: 'page/get',
        payload: {
          pageId: this.pageId,
          url: url,
          response: table_name,
          params: params
        }
      }).then(function (data) {// if (data != null) {
        // this.searchUploadFileList(searchUrl)
        // }
      });
    }
  }, {
    key: "save",
    value: function save() {
      var _this2 = this;

      var requestProject = this.props.requestProject;
      var _this$props$page$this = this.props.page[this.pageId],
          formData = _this$props$page$this.formData,
          bindedEntity = _this$props$page$this.bindedEntity;
      var id = this.props.match.params.id;

      if (id == null && formData.flag == null) {
        formData.flag = 'I';
      } else {
        formData.flag = 'U';
      }

      var table_name = bindedEntity.table_name;
      var method = table_name.replace('_', '.') + '.save';
      var url = "/".concat(requestProject, "/rest?com_id=0&method=").concat(method);
      return this.props.dispatch({
        type: 'page/save',
        payload: {
          pageId: this.pageId,
          url: url,
          response: table_name,
          params: {
            data: formData
          }
        }
      }).then(function (data) {
        _this2.searchOperationLogs();

        return data;
      });
    }
  }, {
    key: "getEntityOperateUrl",
    value: function getEntityOperateUrl(type) {
      var requestProject = this.props.requestProject;
      var bindedEntity = this.props.page[this.pageId].bindedEntity;
      var table_name = bindedEntity.table_name;
      var method = table_name.replace('_', '.') + '.' + type;
      var url = "/".concat(requestProject, "/rest?com_id=0&method=").concat(method);
      return url;
    }
  }, {
    key: "getEntityTableName",
    value: function getEntityTableName() {
      var bindedEntity = this.props.page[this.pageId].bindedEntity;
      return bindedEntity.table_name;
    }
  }, {
    key: "del",
    value: function del() {
      var _this3 = this;

      return new Promise(function (reslove) {
        _modal.default.alert('是否删除单据？', '', [{
          text: '取消',
          onPress: function onPress() {
            return console.log('cancel');
          }
        }, {
          text: '确定',
          onPress: function onPress() {
            var requestProject = _this3.props.requestProject;
            var _this3$props$page$_th = _this3.props.page[_this3.pageId],
                formData = _this3$props$page$_th.formData,
                bindedEntity = _this3$props$page$_th.bindedEntity;
            var table_name = bindedEntity.table_name;
            var method = table_name.replace('_', '.') + '.save';
            var url = "/".concat(requestProject, "/rest?com_id=0&method=").concat(method);

            _this3.props.dispatch({
              type: 'page/del',
              payload: {
                pageId: _this3.pageId,
                url: url,
                response: table_name,
                params: {
                  data: formData
                }
              }
            }).then(function (id) {
              reslove(id);
            });
          }
        }]);
      });
    }
  }, {
    key: "loadDesign",
    value: function loadDesign() {
      var _this4 = this;

      var _this$props2 = this.props,
          requestProject = _this$props2.requestProject,
          match = _this$props2.match,
          location = _this$props2.location;
      var pageInit = null;
      var type = '';

      if (location.params != null) {
        if (location.params.pageInit != null) {
          pageInit = location.params.pageInit.bind(this);
        }

        if (location.params.type != null) {
          type = location.params.type;
        }
      }

      var _match$params = match.params,
          pageId = _match$params.pageId,
          id = _match$params.id;

      if (pageId != null && pageId != '') {
        var pageKey = '';

        for (var i = 1; i < localStorage.length; i += 1) {
          var key = localStorage.key(i);

          if (key != null && key.indexOf("".concat(pageId, "_page")) != -1) {
            pageKey = key;
          }
        }

        if (pageKey == '') {
          this.props.dispatch({
            type: 'page/loadDesign',
            payload: {
              requestProject: requestProject,
              pageId: pageId
            }
          }).then(function () {
            if (type == 'edit' || type == 'add') {
              if (id != null && id != '') {
                _this4.get({
                  f_id: id
                });
              } else {
                _this4.edit();
              }
            }

            if (pageInit) {
              setTimeout(function () {
                pageInit();
              }, 200);
            }
          });
        } else {
          var pageData = JSON.parse(localStorage.getItem(pageKey));
          var entityData = JSON.parse(localStorage.getItem("".concat(pageId, "_entity")));
          this.props.dispatch({
            type: 'page/loadDesignSuccess',
            payload: {
              pageId: pageId,
              pageName: pageData.page_name,
              isClearState: pageData.is_clear_state,
              pageJson: JSON.parse(pageData.page_json),
              bindedEntity: entityData
            }
          });
          setTimeout(function () {
            if (type == 'edit' || type == 'add') {
              if (id != null && id != '') {
                _this4.get({
                  f_id: id
                });
              } else {
                _this4.edit();
              }
            }

            if (pageInit) {
              setTimeout(function () {
                pageInit();
              }, 200);
            }
          }, 200);
        }
      }
    }
  }, {
    key: "openDetailForm",
    value: function openDetailForm(detailId, item) {
      var pageState = this.props.page[this.pageId];
      var pageJson = pageState.pageJson;
      var control = this.findControlById(pageJson, detailId);
      var properties = control.properties;
      var detailKey = '';

      for (var i = 0; i < properties.length; i += 1) {
        var property = properties[i];

        if (property.key == 'bindField') {
          detailKey = property.value;
        }
      }

      this.props.dispatch({
        type: 'page/stateChange',
        payload: {
          pageId: this.pageId,
          params: {
            detailFormKey: detailKey,
            detailFormVisible: true,
            detailFormData: item
          }
        }
      });
    }
  }, {
    key: "closeDetailForm",
    value: function closeDetailForm() {
      this.props.dispatch({
        type: 'page/stateChange',
        payload: {
          pageId: this.pageId,
          params: {
            detailFormKey: '',
            detailFormVisible: false,
            detailFormData: {}
          }
        }
      });
    }
  }, {
    key: "loadDict",
    value: function loadDict() {
      var requestProject = this.props.requestProject;
      this.props.dispatch({
        type: 'page/loadDict',
        payload: {
          requestProject: requestProject
        }
      });
    }
  }, {
    key: "search",
    value: function search(params) {
      var _this$props3 = this.props,
          requestProject = _this$props3.requestProject,
          match = _this$props3.match;
      var pageId = match.params.pageId;
      var bindedEntity = this.props.page[this.pageId].bindedEntity;
      var table_name = bindedEntity.table_name;
      var method = table_name.replace('_', '.') + '.search';
      var url = "/".concat(requestProject, "/rest?com_id=0&method=").concat(method);
      this.props.dispatch({
        type: 'page/search',
        payload: {
          url: url,
          response: table_name,
          pageId: pageId,
          params: params
        }
      });
    }
  }, {
    key: "findControlById",
    value: function findControlById(components, id) {
      for (var i = 0; i < components.length; i += 1) {
        var property = components[i];

        if (property.id == id) {
          return property;
        } else {
          var result = this.findControlById(property.components, id);

          if (result != null) {
            return result;
          }
        }
      }
    }
  }, {
    key: "post",
    value: function post(url, params) {
      return this.props.dispatch({
        type: 'page/post',
        payload: {
          url: url,
          params: params
        }
      });
    }
  }, {
    key: "openDataImport",
    value: function openDataImport(importUrl, exportUrl, fileName, fields, importResponse) {
      if (importUrl == null || importUrl == '') {
        message.warn('明细导入未配置importUrl', 2);
        return;
      }

      if (exportUrl == null || exportUrl == '') {
        message.warn('明细导入未配置exportUrl', 2);
        return;
      }

      if (fileName == null || fileName == '') {
        message.warn('明细导入未配置fileName', 2);
        return;
      }

      if (fields == null || fields == '') {
        message.warn('明细导入未配置fields', 2);
        return;
      }

      if (importResponse == null || importResponse == '') {
        message.warn('明细导入未配置response', 2);
        return;
      }

      this.props.dispatch({
        type: 'page/stateChange',
        payload: {
          pageId: this.pageId,
          params: {
            importVisible: true,
            importUrl: importUrl,
            exportUrl: exportUrl,
            importFileName: fileName,
            importFields: fields,
            importResponse: importResponse
          }
        }
      });
    }
  }, {
    key: "closeDataImport",
    value: function closeDataImport() {
      this.props.dispatch({
        type: 'page/stateChange',
        payload: {
          pageId: this.pageId,
          params: {
            importVisible: false,
            importUrl: '',
            exportUrl: '',
            importFileName: '',
            importFields: '',
            importResponse: ''
          }
        }
      });
    }
  }, {
    key: "openQuery",
    value: function openQuery() {
      this.props.dispatch({
        type: 'page/stateChange',
        payload: {
          pageId: this.pageId,
          params: {
            queryViewVisible: true
          }
        }
      });
    }
  }, {
    key: "queryOpenChange",
    value: function queryOpenChange() {
      this.props.dispatch({
        type: 'page/stateChange',
        payload: {
          pageId: this.pageId,
          params: {
            queryViewVisible: !this.props.page[this.pageId].queryViewVisible
          }
        }
      });
    }
  }, {
    key: "addDetail",
    value: function addDetail(detailId, defaultData) {
      var pageState = this.props.page[this.pageId];
      var pageJson = pageState.pageJson;
      var control = this.findControlById(pageJson, detailId);
      var properties = control.properties;
      var detailTableColumns = [];
      var detailKey = '';
      var rowKey = 'f_id';

      for (var i = 0; i < properties.length; i += 1) {
        var property = properties[i];

        if (property.type == 'commonDetailColumns') {
          detailTableColumns = property.value;
        }

        if (property.key == 'bindField') {
          detailKey = property.value;
        }
      }

      var detailData = {};

      for (var _i = 0; _i < detailTableColumns.length; _i += 1) {
        var column = detailTableColumns[_i];
        var bindFieldProperty = column.properties.find(function (item) {
          return item.key == 'bindField';
        });

        if (bindFieldProperty != null && bindFieldProperty.value != '') {
          detailData[bindFieldProperty.value] = '';
        }
      }

      detailData = _objectSpread({}, detailData, defaultData);
      detailData[rowKey] = new Date().getTime();
      detailData.flag = 'I';
      return this.props.dispatch({
        type: 'page/addDetail',
        payload: {
          pageId: this.pageId,
          params: {
            detailKey: detailKey,
            detailData: detailData
          }
        }
      });
    }
  }, {
    key: "delDetail",
    value: function delDetail(detailId, dataId) {
      var pageState = this.props.page[this.pageId];
      var pageJson = pageState.pageJson;
      var control = this.findControlById(pageJson, detailId);
      var properties = control.properties;
      var rowKey = 'f_id';
      var detailKey = '';

      for (var i = 0; i < properties.length; i += 1) {
        var property = properties[i];

        if (property.key == 'bindField') {
          detailKey = property.value;
        }
      }

      return this.props.dispatch({
        type: 'page/delDetail',
        payload: {
          pageId: this.pageId,
          params: {
            rowKey: rowKey,
            detailKey: detailKey,
            dataId: dataId
          }
        }
      });
    }
  }, {
    key: "searchOperationLogs",
    value: function searchOperationLogs() {
      var _this5 = this;

      var pageState = this.props.page[this.pageId];
      var requestProject = this.props.requestProject;
      var formData = pageState.formData,
          bindedEntity = pageState.bindedEntity;
      var tableName = bindedEntity.table_name;
      var method = tableName.replace('_', '.');
      return new Promise(
      /*#__PURE__*/
      function () {
        var _ref = _asyncToGenerator(
        /*#__PURE__*/
        _regenerator.default.mark(function _callee(resolve) {
          var param, rtnData, data;
          return _regenerator.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  param = {
                    url: "/".concat(requestProject, "/rest?com_id=0&method=").concat(method, ".getoperationlogs"),
                    params: {
                      dataid: formData.f_id
                    }
                  };
                  _context.next = 3;
                  return (0, _service.post)(param);

                case 3:
                  rtnData = _context.sent;

                  if (rtnData != null && rtnData['operationlogs'] != null) {
                    data = rtnData['operationlogs'];

                    _this5.props.dispatch({
                      type: 'page/stateChange',
                      payload: {
                        pageId: _this5.pageId,
                        params: {
                          operationLogs: data
                        }
                      }
                    });
                  }

                  resolve('success');

                case 6:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));

        return function (_x) {
          return _ref.apply(this, arguments);
        };
      }());
    }
  }, {
    key: "renderComponents",
    value: function renderComponents(pageJson, selectedControl) {
      var _this6 = this;

      var controls = [];

      var _loop = function _loop(i) {
        var component = pageJson[i];
        var id = component.id,
            type = component.type,
            independent = component.independent,
            components = component.components,
            properties = component.properties;

        var propertiesJson = _this6.getPropertiesJson(properties);

        var Control = _ControlFactory.default.getControl(type);

        var pageState = _this6.props.page[_this6.pageId];
        var formData = pageState.formData;
        var options = {
          pageId: _this6.pageId
        };
        var style = propertiesJson.style;

        if (style != null && style != '') {
          var event = new Function(style).bind(_this6);
          options.style = _objectSpread({}, event());
        }

        if (type != 'grid' && type != 'list' && type != 'navBar') {
          options.setFormValues = _this6.setFormValues.bind(_this6);
          var bindField = propertiesJson.bindField,
              onChangeEvent = propertiesJson.onChangeEvent;

          if (bindField != null && bindField != '') {
            options.value = formData[bindField];
          }

          options.formData = formData;

          var onChange = function onChange(val, rowData) {
            var values = {};
            values[bindField] = val;

            _this6.setFormValues(values);

            if (onChangeEvent != null && onChangeEvent !== '') {
              var code = Babel.transform(onChangeEvent, {
                presets: [require('@babel/preset-react')],
                parserOpts: {
                  allowReturnOutsideFunction: true
                }
              }).code;

              var _event = new Function('React', 'value', 'rowData', 'setFormValues', 'formData', 'AntdMobile', code).bind(_this6);

              _event(_react.default, val, rowData, _this6.setFormValues.bind(_this6), formData, antdMobile);
            }
          };

          options.onChange = onChange.bind(_this6);
          options.operationType = pageState.operationType;
        }

        if (type == 'navBar') {
          var icon = propertiesJson.icon,
              onLeftClick = propertiesJson.onLeftClick,
              rightContent = propertiesJson.rightContent,
              title = propertiesJson.title;

          if (icon != null && icon != '') {
            var iconCode = Babel.transform(icon, {
              presets: [require('@babel/preset-react')],
              parserOpts: {
                allowReturnOutsideFunction: true
              }
            }).code;

            var _event2 = new Function('React', 'AntdMobile', iconCode).bind(_this6);

            options.icon = _event2(_react.default, antdMobile);
          }

          if (rightContent != null && rightContent != '') {
            var rightContentCode = Babel.transform(rightContent, {
              presets: [require('@babel/preset-react')],
              parserOpts: {
                allowReturnOutsideFunction: true
              }
            }).code;

            var _event3 = new Function('React', 'AntdMobile', rightContentCode).bind(_this6);

            options.rightContent = _event3(_react.default, antdMobile);
          }

          if (title != null && title != '') {
            var titleCode = Babel.transform(title, {
              presets: [require('@babel/preset-react')],
              parserOpts: {
                allowReturnOutsideFunction: true
              }
            }).code;

            try {
              var _event4 = new Function('React', 'AntdMobile', titleCode).bind(_this6);

              options.title = _event4(_react.default, antdMobile);
            } catch (e) {}
          }

          if (onLeftClick != null && onLeftClick != '') {
            var onLeftClickCode = Babel.transform(onLeftClick, {
              presets: [require('@babel/preset-react')],
              parserOpts: {
                allowReturnOutsideFunction: true
              }
            }).code;

            var _event5 = new Function('React', 'AntdMobile', onLeftClickCode).bind(_this6);

            options.onLeftClick = function () {
              _event5(_react.default, antdMobile);
            };
          }
        }

        if (type == 'grid') {
          var onClick = propertiesJson.onClick;

          if (onClick != null && onClick != '') {
            options.onClick = function (el, index) {
              var event = new Function('e', 'index', 'React', 'AntdMobile', onClick).bind(_this6);
              event(el, index, _react.default, antdMobile);
            };
          }
        }

        if (type == 'list') {
          var renderListItemEvent = propertiesJson.renderListItemEvent,
              onSearchEvent = propertiesJson.onSearchEvent;
          var tableData = pageState.tableData,
              searchParams = pageState.searchParams,
              queryViewVisible = pageState.queryViewVisible,
              totalCount = pageState.totalCount,
              loading = pageState.loading;

          options.onSearch = function (params) {
            var event = new Function('params', 'AntdMobile', onSearchEvent).bind(_this6);
            event(params, antdMobile);
          };

          if (renderListItemEvent != null && renderListItemEvent != '') {
            var code = Babel.transform(renderListItemEvent, {
              presets: [require('@babel/preset-react')],
              parserOpts: {
                allowReturnOutsideFunction: true
              }
            }).code;

            var _event6 = new Function('item', 'React', 'AntdMobile', code).bind(_this6);

            options.renderListItem = function (item) {
              return _event6(item, _react.default, antdMobile);
            };
          }

          options.queryViewVisible = queryViewVisible;
          options.queryOpenChange = _this6.queryOpenChange.bind(_this6);
          options.dataSource = tableData;
          options.searchParams = searchParams;
          options.totalCount = parseInt(totalCount);
          options.loading = loading;
          options.dict = _this6.props.page.dict;
        }

        if (type == 'picker') {
          var dictCode = propertiesJson.dictCode,
              dataFilterEvent = propertiesJson.dataFilterEvent;

          if (dictCode != null && dictCode != '') {
            var dict = _this6.props.page.dict;
            propertiesJson.options = (0, _dictUtil.default)(dict[dictCode]);
          }

          if (dataFilterEvent != null && dataFilterEvent != '') {
            var _event7 = new Function('options', dataFilterEvent).bind(_this6);

            propertiesJson.dataFilter = function (ops) {
              return _event7(ops);
            };
          }
        }

        if (type == 'button') {
          var isVisible = propertiesJson.isVisible,
              onClickEvent = propertiesJson.onClickEvent;

          if (isVisible != null && isVisible !== '') {
            var _event8 = new Function('formData', 'AntdMobile', "".concat(isVisible)).bind(_this6);

            options.visible = _event8(formData, antdMobile);
          }

          if (onClickEvent != null && onClickEvent != '') {
            var _code = Babel.transform(onClickEvent, {
              presets: [require('@babel/preset-react')],
              parserOpts: {
                allowReturnOutsideFunction: true
              }
            }).code;

            var _event9 = new Function('React', 'AntdMobile', _code).bind(_this6);

            options.onClick = function () {
              _event9(_react.default, antdMobile);
            };
          }
        } else if (type == 'tabs') {
          var onTabClickEvent = propertiesJson.onTabClickEvent;

          if (onTabClickEvent != null && onTabClickEvent != '') {
            try {
              var onClickCode = Babel.transform(onTabClickEvent, {
                presets: [require('@babel/preset-react')],
                parserOpts: {
                  allowReturnOutsideFunction: true
                }
              }).code;

              var _event10 = new Function('React', 'AntdMobile', 'tab', 'index', onClickCode).bind(_this6);

              options.onClick = function (tab, index) {
                _event10(_react.default, antdMobile, tab, index);
              };
            } catch (e) {
              console.error(e);
            }
          } else {
            options.onClick = function () {};
          }
        } else if (type == 'tabPane') {
          var isVisibleEvent = propertiesJson.isVisibleEvent;
          var visible = true;

          if (isVisibleEvent != null && isVisibleEvent != '') {
            try {
              var isVisibleCode = Babel.transform(isVisibleEvent, {
                presets: [require('@babel/preset-react')],
                parserOpts: {
                  allowReturnOutsideFunction: true
                }
              }).code;

              var _event11 = new Function('React', 'AntdMobile', isVisibleCode).bind(_this6);

              visible = _event11(_react.default, antdMobile);
            } catch (e) {
              console.error(e);
            }
          }

          options.isVisible = visible;
        } else if (type == 'commonDetail') {
          var _bindField = propertiesJson.bindField,
              itemRender = propertiesJson.itemRender,
              buttons = propertiesJson.buttons;
          var detailData = formData[_bindField] == null ? [] : formData[_bindField];
          options.dict = _this6.props.page.dict;
          options.loading = pageState.loading;
          options.dispatch = _this6.props.dispatch;
          options.history = _this6.props.history;
          options.pageId = _this6.pageId;
          options.formData = formData;
          options.post = _this6.post.bind(_this6);
          ;
          options.operationType = pageState.operationType;
          options.antdMobile = antdMobile;
          options.detailData = detailData.filter(function (item) {
            return item.flag != 'D';
          });

          options.setFormValues = function (values) {
            for (var key in values) {
              var value = values[key];
              formData[key] = value;
            }

            _this6.forceUpdate();
          };

          options.openDetailForm = _this6.openDetailForm.bind(_this6);
          options.closeDetailForm = _this6.closeDetailForm.bind(_this6);
          options.detailFormVisible = pageState.detailFormVisible && pageState.detailFormKey == _bindField;
          options.detailFormData = pageState.detailFormData;

          options.updateDetailData = function (item) {
            for (var j = 0; j < formData[_bindField].length; j += 1) {
              if (formData[_bindField][j].f_id == item.f_id) {
                formData[_bindField][j] = item;
              }
            }

            _this6.props.dispatch({
              type: 'page/stateChange',
              payload: {
                pageId: _this6.pageId,
                params: {
                  formData: formData
                }
              }
            });
          };

          if (itemRender != null && itemRender != '') {
            try {
              var itemRenderCode = Babel.transform(itemRender, {
                presets: [require('@babel/preset-react')],
                parserOpts: {
                  allowReturnOutsideFunction: true
                }
              }).code;

              var _event12 = new Function('React', 'AntdMobile', 'detailData', itemRenderCode).bind(_this6);

              options.itemRender = function (data) {
                return _event12(_react.default, antdMobile, data);
              };
            } catch (e) {
              console.error(e);
            }
          } else {
            options.itemRender = function () {};
          }

          var _loop2 = function _loop2(j) {
            var _buttons$j = buttons[j],
                onClickEvent = _buttons$j.onClickEvent,
                isVisibleEvent = _buttons$j.isVisibleEvent;

            if (onClickEvent != null && onClickEvent !== '') {
              var _onClick = function _onClick(item) {
                var code = Babel.transform(onClickEvent, {
                  presets: [require('@babel/preset-react')],
                  parserOpts: {
                    allowReturnOutsideFunction: true
                  }
                }).code;
                var event = new Function('React', 'AntdMobile', 'item', code).bind(_this6);
                event(_react.default, antdMobile, item);
              };

              buttons[j].onClick = _onClick.bind(_this6);
            }

            if (isVisibleEvent != null && isVisibleEvent !== '') {
              var _event13 = new Function('AntdMobile', isVisibleEvent).bind(_this6);

              buttons[j].isVisible = _event13.bind(antdMobile, _this6);
            }
          };

          for (var j = 0; j < buttons.length; j += 1) {
            _loop2(j);
          }
        } else if (type == 'tabBar') {
          var hiddenEvent = propertiesJson.hiddenEvent;

          if (hiddenEvent != null && hiddenEvent != '') {
            var _event14 = _this6.transformJSX(hiddenEvent);

            options.hidden = _event14(_react.default, antdMobile);
          }
        } else if (type == 'tabBarItem') {
          var key = propertiesJson.key,
              _title = propertiesJson.title,
              badgeCount = propertiesJson.badgeCount,
              _icon = propertiesJson.icon,
              selectedIcon = propertiesJson.selectedIcon,
              selectedEvent = propertiesJson.selectedEvent,
              onPressEvent = propertiesJson.onPressEvent;
          options.key = key;
          options.title = _title;

          if (_icon != null && _icon != '') {
            var _event15 = _this6.transformJSX(_icon);

            options.icon = _event15(_react.default, antdMobile);
          }

          if (badgeCount != null && badgeCount != '') {
            var _event16 = _this6.transformJSX(badgeCount);

            options.badge = _event16(_react.default, antdMobile);
          }

          if (selectedIcon != null && selectedIcon != '') {
            var _event17 = _this6.transformJSX(selectedIcon);

            options.selectedIcon = _event17(_react.default, antdMobile);
          }

          if (selectedEvent != null && selectedEvent != '') {
            var _event18 = _this6.transformJSX(selectedEvent);

            options.selected = _event18(_react.default, antdMobile);
          }

          if (onPressEvent != null && onPressEvent != '') {
            var _event19 = _this6.transformJSX(onPressEvent);

            options.onPress = function () {
              _event19(_react.default, antdMobile);
            };
          }
        } else if (type == 'antdList') {
          var headerRender = propertiesJson.headerRender,
              items = propertiesJson.items,
              searchEvent = propertiesJson.searchEvent;

          if (headerRender != null && headerRender != '') {
            var _event20 = _this6.transformJSX(headerRender);

            options.header = _event20(_react.default, antdMobile);
          }

          var content = [];

          for (var j = 0; j < items.length; j += 1) {
            var item = items[j];
            var _isVisibleEvent = item.isVisibleEvent,
                name = item.name;

            if (_isVisibleEvent != null && _isVisibleEvent != '') {
              var _event21 = _this6.transformJSX(_isVisibleEvent);

              item.isVisible = _event21(_react.default, antdMobile);

              if (!item.isVisible) {
                continue;
              }
            }

            if (name != null && name != '') {
              var _event22 = _this6.transformJSX(name);

              content.push(_event22(_react.default, antdMobile));
            }
          }

          options.content = content;

          if (searchEvent != null && searchEvent != '') {
            var _event23 = _this6.transformJSX(searchEvent);

            options.search = function () {
              return _event23(_react.default, antdMobile);
            };
          }
        } else if (type == 'bpmTable') {
          var codeField = propertiesJson.codeField;
          var bindedEntity = pageState.bindedEntity;
          options.processKey = bindedEntity.process_key;
          options.code = formData[codeField];

          if (formData.f_id == null) {
            return {
              v: _react.default.createElement("div", null)
            };
          }
        } else if (type == 'operationLogsTable') {
          options.tableData = pageState.operationLogs;
          options.search = _this6.searchOperationLogs.bind(_this6);

          if (formData.f_id == null) {
            return {
              v: _react.default.createElement("div", null)
            };
          }
        } else if (type == 'uploadTable') {
          var uploadFileList = pageState.uploadFileList;
          options.pageId = _this6.pageId;
          options.formData = formData;
          options.fileList = uploadFileList;
          options.dispatch = _this6.props.dispatch;
        } else if (type == 'imagePicker') {
          var _bindField2 = propertiesJson.bindField,
              _onChangeEvent = propertiesJson.onChangeEvent;

          if (_bindField2 != null && _bindField2 != '') {
            options.value = formData[_bindField2];
          }

          options.formData = formData;

          var _onChange = function _onChange(files, operationType, index) {
            if (_onChangeEvent != null && _onChangeEvent !== '') {
              var _code2 = Babel.transform(_onChangeEvent, {
                presets: [require('@babel/preset-react')],
                parserOpts: {
                  allowReturnOutsideFunction: true
                }
              }).code;

              var _event24 = new Function('React', 'fetch', 'files', 'operationType', 'index', 'AntdMobile', _code2).bind(_this6);

              _event24(_react.default, _fetch.default, files, operationType, index, antdMobile);
            }
          };

          options.onChange = _onChange.bind(_this6);
        } else if (type == 'searchPicker') {
          var queryConfig = propertiesJson.queryConfig;
          var queryConfigFn = new Function('formData', "return ".concat(queryConfig)).bind(_this6);
          options.queryConfig = queryConfigFn(formData);
        }

        if (propertiesJson.name != null && propertiesJson.isRequired != null && propertiesJson.isRequired == '1') {
          var _code3 = "return <div>".concat(propertiesJson.name, "<span style={{ color: \"red\" }}>*</span></div>;");

          var _event25 = _this6.transformJSX(_code3);

          options.name = _event25(_react.default, antdMobile);
        }

        if (propertiesJson.isVisible != null && propertiesJson.isVisible !== '') {
          var _event26 = new Function('formData', 'AntdMobile', "".concat(propertiesJson.isVisible)).bind(_this6);

          options.isVisible = _event26(formData, antdMobile);
        }

        if (propertiesJson.isEnabled != null && propertiesJson.isEnabled !== '') {
          var _event27 = new Function('formData', 'AntdMobile', "".concat(propertiesJson.isEnabled)).bind(_this6);

          options.disabled = !_event27(formData, antdMobile);
        }

        var children = _this6.renderComponents(components, selectedControl);

        controls.push(_react.default.createElement(Control, _extends({
          key: id,
          id: id,
          designmode: "false",
          independent: independent,
          selected: selectedControl.id == id
        }, propertiesJson, options), children == null || children.length == 0 ? _react.default.createElement("span", null, "\xA0") : children));
      };

      for (var i = 0; i < pageJson.length; i += 1) {
        var _ret = _loop(i);

        if (_typeof(_ret) === "object") return _ret.v;
      }

      return controls;
    }
  }, {
    key: "transformJSX",
    value: function transformJSX(code) {
      var event = null;

      try {
        var c = Babel.transform(code, {
          presets: [require('@babel/preset-react')],
          parserOpts: {
            allowReturnOutsideFunction: true
          }
        }).code;
        event = new Function('React', 'AntdMobile', c).bind(this);
      } catch (e) {
        console.error(e);
      }

      return event;
    }
  }, {
    key: "render",
    value: function render() {
      var pageState = this.props.page[this.pageId];

      if (pageState == null) {
        return _react.default.createElement("div", {
          className: "loader"
        }, _react.default.createElement("div", {
          className: "loader-inner"
        }, _react.default.createElement("div", {
          className: "loader-line-wrap"
        }, _react.default.createElement("div", {
          className: "loader-line"
        })), _react.default.createElement("div", {
          className: "loader-line-wrap"
        }, _react.default.createElement("div", {
          className: "loader-line"
        })), _react.default.createElement("div", {
          className: "loader-line-wrap"
        }, _react.default.createElement("div", {
          className: "loader-line"
        })), _react.default.createElement("div", {
          className: "loader-line-wrap"
        }, _react.default.createElement("div", {
          className: "loader-line"
        })), _react.default.createElement("div", {
          className: "loader-line-wrap"
        }, _react.default.createElement("div", {
          className: "loader-line"
        }))));
      }

      var pageJson = pageState.pageJson,
          formData = pageState.formData,
          loading = pageState.loading,
          exportVisible = pageState.exportVisible,
          exportUrl = pageState.exportUrl,
          exportFileName = pageState.exportFileName,
          exportFields = pageState.exportFields,
          exportSearchParams = pageState.exportSearchParams,
          importVisible = pageState.importVisible,
          importUrl = pageState.importUrl,
          importFileName = pageState.importFileName,
          importFields = pageState.importFields,
          importResponse = pageState.importResponse,
          queryViewVisible = pageState.queryViewVisible,
          bindedEntity = pageState.bindedEntity,
          searchParams = pageState.searchParams;
      var _this$state = this.state,
          batchSetDetailValueVisible = _this$state.batchSetDetailValueVisible,
          batchSetDetailKey = _this$state.batchSetDetailKey,
          batchSetDetailColumns = _this$state.batchSetDetailColumns;
      var fields = bindedEntity.fields;
      var tableFields = [];

      for (var i = 0; i < fields.length; i += 1) {
        var field = fields[i];

        if (field.type.indexOf('com.') == -1) {
          tableFields.push(field);
        }
      }

      return _react.default.createElement("div", {
        id: "pageRoot",
        style: {
          display: 'flex',
          flexDirection: 'column'
        }
      }, this.renderComponents(pageJson, {}));
    }
  }]);

  return PageDetail;
}(_react.default.Component);

function mapStateToProps(state, ownProps) {
  var page = state.page;
  var pageId = ownProps.match.params.pageId;

  if (pageId != null && page[pageId] != null) {
    page[pageId].loading = state.loading.models.page;
  }

  return {
    page: page,
    loading: state.loading.global
  };
}

var _default = (0, _dva.connect)(mapStateToProps)(PageDetail);

exports.default = _default;