"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.object.set-prototype-of");

require("antd-mobile/es/button/style");

var _button = _interopRequireDefault(require("antd-mobile/es/button"));

require("antd-mobile/es/list/style");

var _list = _interopRequireDefault(require("antd-mobile/es/list"));

require("antd-mobile/es/input-item/style");

var _inputItem = _interopRequireDefault(require("antd-mobile/es/input-item"));

require("antd-mobile/es/white-space/style");

var _whiteSpace = _interopRequireDefault(require("antd-mobile/es/white-space"));

require("core-js/modules/es6.regexp.split");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

require("regenerator-runtime/runtime");

require("core-js/modules/es6.promise");

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

require("./Login.less");

var _md = _interopRequireDefault(require("../md5.min"));

var _service = require("../service");

var _loginSuccess2 = _interopRequireDefault(require("./loginSuccess"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Login =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Login, _React$Component);

  function Login(props, context) {
    var _this;

    _classCallCheck(this, Login);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Login).call(this, props, context));
    _this.state = {
      userName: '',
      password: '',
      appList: [],
      appCode: '',
      loading: false
    };
    return _this;
  }

  _createClass(Login, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      sessionStorage.removeItem('title');
      sessionStorage.removeItem('menus');
      sessionStorage.removeItem('token');
      sessionStorage.removeItem('loginUser');
      sessionStorage.removeItem('activeKey');
      sessionStorage.removeItem('collapsed');
      sessionStorage.removeItem('openKeys');
      sessionStorage.removeItem('org');
    }
  }, {
    key: "handleSubmit",
    value: function handleSubmit(e) {
      var _this2 = this;

      this.setState({
        loading: true
      });
      e.preventDefault();
      var _this$state = this.state,
          userName = _this$state.userName,
          password = _this$state.password;
      new Promise(
      /*#__PURE__*/
      function () {
        var _ref = _asyncToGenerator(
        /*#__PURE__*/
        _regenerator.default.mark(function _callee(resolve) {
          var data;
          return _regenerator.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.next = 2;
                  return (0, _service.post)({
                    url: '/upms/rest?com_id=0&method=upms.user.login',
                    params: {
                      f_code: userName,
                      f_password: (0, _md.default)(password)
                    }
                  });

                case 2:
                  data = _context.sent;

                  _this2.setState({
                    loading: false
                  });

                  if (data != null && data['upms_user'] != null) {
                    _this2.checkPageCache().then(function () {
                      _this2.loginSuccess(data['upms_user']);
                    });
                  }

                  resolve(data);

                case 6:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));

        return function (_x) {
          return _ref.apply(this, arguments);
        };
      }());
    }
  }, {
    key: "checkPageCache",
    value: function checkPageCache() {
      var _this3 = this;

      var pageIds = [];

      for (var i = 1; i <= localStorage.length; i += 1) {
        var key = localStorage.key(i);

        if (key != null && key.indexOf('_page') != -1) {
          pageIds.push(key.split('_')[0]);
        }
      }

      return new Promise(
      /*#__PURE__*/
      function () {
        var _ref2 = _asyncToGenerator(
        /*#__PURE__*/
        _regenerator.default.mark(function _callee2(resolve) {
          var data, pages, _i, page, j, _key, version;

          return _regenerator.default.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  _context2.next = 2;
                  return (0, _service.post)({
                    url: "/".concat(_this3.props.requestProject, "/rest?com_id=0&method=design.page.search"),
                    params: {
                      1: 1,
                      f_id: {
                        $in: pageIds
                      },
                      fields: 'f_id,version'
                    }
                  });

                case 2:
                  data = _context2.sent;

                  if (data != null && data['design_page'] != null) {
                    pages = data['design_page'];

                    for (_i = 0; _i < pages.length; _i += 1) {
                      page = pages[_i];

                      for (j = 1; j <= localStorage.length; j += 1) {
                        _key = localStorage.key(j);

                        if (_key != null && _key.indexOf('_page') != -1 && _key.indexOf(page.f_id) != -1) {
                          version = _key.split('-')[2];

                          if (version != page.version) {
                            localStorage.removeItem(_key);
                            localStorage.removeItem("".concat(page.f_id, "_entity"));
                          }
                        }
                      }
                    }
                  }

                  resolve(data);

                case 5:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2, this);
        }));

        return function (_x2) {
          return _ref2.apply(this, arguments);
        };
      }());
    }
  }, {
    key: "loginSuccess",
    value: function loginSuccess(user) {
      var appCode = this.state.appCode;
      (0, _loginSuccess2.default)(appCode, user['menuauthlist'], user['btnauthlist'], user['token'], user);
      this.props.history.push(this.props.redirectPath);
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var _this$state2 = this.state,
          userName = _this$state2.userName,
          password = _this$state2.password,
          appList = _this$state2.appList,
          appCode = _this$state2.appCode,
          loading = _this$state2.loading;

      if (appList.length > 0) {
        var firstMenu = {};
        var firstMenuInx = -1;

        for (var i = 0; i < appList.length; i += 1) {
          if (appList[i].f_code == this.props.appCode) {
            firstMenu = appList[i];
            firstMenuInx = i;
          }
        }

        if (firstMenuInx != -1) {
          appList.splice(firstMenuInx, 1);
          appList.splice(0, 0, firstMenu);
        }

        if (appCode == '') {
          this.state.appCode = firstMenu.f_code;
        }
      }

      return _react.default.createElement("div", {
        style: {
          width: '100%',
          minHeight: '100%',
          backgroundImage: "url('svgs/bg.svg')",
          backgroundRepeat: 'no-repeat',
          backgroundPosition: 'center',
          backgroundSize: '100%',
          padding: '110px 0 144px 0',
          position: 'relative'
        }
      }, _react.default.createElement("div", {
        className: "login-main",
        style: {
          minHeight: (window.innerHeight - 254) * 0.9,
          width: '368px',
          margin: '0 auto',
          textAlign: 'center'
        }
      }, _react.default.createElement("h1", null, "\u6B66\u6E90CRM"), _react.default.createElement(_whiteSpace.default, {
        size: "xl"
      }), _react.default.createElement(_list.default, null, _react.default.createElement(_inputItem.default, {
        type: "text",
        defaultValue: userName,
        placeholder: "\u7528\u6237\u540D",
        clear: true,
        onChange: function onChange(e) {
          _this4.setState({
            userName: e
          });
        }
      }), _react.default.createElement(_inputItem.default, {
        type: "password",
        defaultValue: password,
        placeholder: "\u5BC6\u7801",
        clear: true,
        onChange: function onChange(e) {
          _this4.setState({
            password: e
          });
        }
      })), _react.default.createElement(_whiteSpace.default, null), _react.default.createElement(_button.default, {
        size: "large",
        loading: loading,
        className: "submit",
        type: "primary",
        onClick: function onClick(e) {
          return _this4.handleSubmit(e);
        }
      }, "\u767B\u5F55"), _react.default.createElement(_whiteSpace.default, {
        size: "xl"
      })), _react.default.createElement("div", {
        style: {
          fontSize: '10px',
          textAlign: 'center',
          width: '100%',
          height: '10%',
          position: 'relative'
        }
      }, "\u5C0F\u80E1\u6768\u4FE1\u606F\u6280\u672F\uFF08\u6B66\u6C49\uFF09\u6709\u9650\u516C\u53F8\u63D0\u4F9B\u6280\u672F\u652F\u6301"));
    }
  }]);

  return Login;
}(_react.default.Component);

Login.propTypes = {
  redirectPath: _propTypes.default.string.isRequired,
  appCode: _propTypes.default.string.isRequired
};
var _default = Login;
exports.default = _default;