"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = dataHandle;

require("antd-mobile/es/modal/style");

var _modal = _interopRequireDefault(require("antd-mobile/es/modal"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function dataHandle(datas) {
  var data = datas.data;

  if (data.returncode != null && data.returncode != '0') {
    if (data.returncode == '50006') {
      var okEvent = function okEvent() {};

      var patchName = window.parent.location.pathname;
      var loginUrl = "".concat(patchName, "#/login");

      if (window.parent != window) {
        okEvent = function okEvent() {
          window.loginTimeoutModal = null;
          window.parent.location.href = loginUrl;
        };
      } else {
        okEvent = function okEvent() {
          window.loginTimeoutModal = null;
          window.location.href = loginUrl;
        };
      }

      if (window.loginTimeoutModal == null) {
        window.loginTimeoutModal = _modal.default.alert('登录超时', '您已登录超时，请重新登录', [{
          text: '取消',
          onPress: function onPress() {
            window.loginTimeoutModal = null;
          }
        }, {
          text: '重新登录',
          onPress: function onPress() {
            return okEvent();
          }
        }]);
      }
    } else {
      _modal.default.alert('错误', data.data, [{
        text: '好的',
        onPress: function onPress() {}
      }]);
    }

    return {};
  } else {
    if (data.data) {
      return data.data;
    } else {
      return data;
    }
  }
}