"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = dictUtil;
exports.getDictName = getDictName;

require("core-js/modules/es6.array.find");

/**
 * Created by F on 2017/9/11.
 */
// import { post } from '../components/service';
function dictUtil(dictData) {
  var data = [];
  if (!dictData) return data;

  for (var i = 0; dictData != null && i < dictData.length; i += 1) {
    var dict = dictData[i];

    for (var key in dict) {
      if (!Object.prototype.hasOwnProperty.call(dict, key)) {
        continue;
      }

      data.push({
        value: key,
        label: dict[key]
      });
    }
  }

  return data; // const param = {
  //   url: '/pdm/rest?com_id=0&method=pdm.dict.getdict',
  //   params: {
  //     dictcode: dictCode,
  //   },
  // }
  // const data = await post(param);
  // return data;
}

function getDictName(dictData, value) {
  if (dictData != null && dictData.length > 0 && dictData[0].value == null) {
    dictData = dictUtil(dictData);
  } else {
    return '';
  }

  var item = dictData.find(function (val) {
    return val.value == value;
  });

  if (item == null) {
    return '';
  }

  return item.label;
}