"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SearchPickerControlProperties = SearchPickerControlProperties;
exports.default = void 0;

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.object.assign");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.object.set-prototype-of");

require("core-js/modules/es6.function.name");

require("antd-mobile/es/modal/style");

var _modal = _interopRequireDefault(require("antd-mobile/es/modal"));

require("antd-mobile/es/button/style");

var _button = _interopRequireDefault(require("antd-mobile/es/button"));

require("antd-mobile/es/list/style");

var _list = _interopRequireDefault(require("antd-mobile/es/list"));

require("antd-mobile/es/search-bar/style");

var _searchBar = _interopRequireDefault(require("antd-mobile/es/search-bar"));

require("core-js/modules/es6.regexp.search");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

require("regenerator-runtime/runtime");

require("core-js/modules/es6.promise");

var _react = _interopRequireDefault(require("react"));

var _dva = require("dva");

var _FormControl2 = _interopRequireDefault(require("../FormControl"));

var _index = _interopRequireDefault(require("../InfiniteScroll/index"));

var _service = require("../../../service");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var SearchPickerControl =
/*#__PURE__*/
function (_FormControl) {
  _inherits(SearchPickerControl, _FormControl);

  function SearchPickerControl(props, context) {
    var _this;

    _classCallCheck(this, SearchPickerControl);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(SearchPickerControl).call(this, props, context));
    _this.state = {
      type: 'searchPicker',
      modalVisible: false,
      queryConfigJson: {},
      visible: false,
      selectedRowKeys: [],
      selectedRows: [],
      pageSize: 20,
      pageNo: 1,
      tableData: [],
      totalCount: 0,
      keyword: '',
      loading: false
    };
    return _this;
  }

  _createClass(SearchPickerControl, [{
    key: "search",
    value: function search(val) {
      var _this2 = this;

      this.state.keyword = val;
      var _this$state = this.state,
          keyword = _this$state.keyword,
          queryConfigJson = _this$state.queryConfigJson,
          pageNo = _this$state.pageNo,
          pageSize = _this$state.pageSize;
      var url = queryConfigJson.url,
          response = queryConfigJson.response,
          idKey = queryConfigJson.idKey,
          codeKey = queryConfigJson.codeKey,
          nameKey = queryConfigJson.nameKey;

      var params = _objectSpread({}, queryConfigJson.params, {
        page_no: pageNo,
        page_size: pageSize,
        order_field: idKey,
        order_direction: 'desc'
      });

      if (keyword != null && keyword != '') {
        params['1'] = '1';
        params['$or'] = {};

        for (var i = 0; i < queryConfigJson.searchKeys.length; i += 1) {
          var searchKey = queryConfigJson.searchKeys[i];
          params['$or'][searchKey] = {
            like: "%".concat(keyword, "%")
          };
        }
      }

      return new Promise(
      /*#__PURE__*/
      _asyncToGenerator(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee() {
        var loginUser, param, rtnData, data, tableData;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _this2.setState({
                  loading: true
                });

                loginUser = JSON.parse(sessionStorage.getItem('loginUser'));

                if (!(loginUser == null)) {
                  _context.next = 4;
                  break;
                }

                return _context.abrupt("return");

              case 4:
                param = {
                  url: url,
                  params: params
                };
                _context.next = 7;
                return (0, _service.post)(param);

              case 7:
                rtnData = _context.sent;

                if (rtnData != null && rtnData[response] != null) {
                  data = rtnData[response];
                  tableData = _this2.state.tableData.concat(data);

                  _this2.setState({
                    tableData: tableData,
                    totalCount: parseInt(rtnData.total_results)
                  });
                }

                _this2.setState({
                  loading: false
                });

              case 10:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      })));
    }
  }, {
    key: "open",
    value: function open() {
      var _this3 = this;

      this.setState({
        modalVisible: true
      }, function () {
        _this3.search();
      });
    }
  }, {
    key: "clear",
    value: function clear() {
      this.setState({
        selectedRowKeys: [],
        selectedRows: [],
        pageSize: 20,
        pageNo: 1,
        tableData: [],
        totalCount: 0,
        keyword: '',
        modalVisible: false
      });
    }
  }, {
    key: "emitEmpty",
    value: function emitEmpty() {
      var onChange = this.props.onChange;
      onChange('', {}); // this.props.setModalValue(this.props.idFormKey, '', this.props.nameFormKey, '', this.state.selectedRows[0]);
    }
  }, {
    key: "renderModal",
    value: function renderModal() {
      var _this4 = this;

      var _this$props = this.props,
          onChange = _this$props.onChange,
          queryConfig = _this$props.queryConfig;
      var options = this.getFormOptions();

      if (!options.readOnly && queryConfig != null) {
        this.state.queryConfigJson = queryConfig;
      }

      var idKey = this.state.queryConfigJson.idKey;
      var _this$state2 = this.state,
          modalVisible = _this$state2.modalVisible,
          queryConfigJson = _this$state2.queryConfigJson,
          pageSize = _this$state2.pageSize,
          pageNo = _this$state2.pageNo,
          tableData = _this$state2.tableData,
          totalCount = _this$state2.totalCount,
          loading = _this$state2.loading;
      var title = queryConfigJson.title,
          searchKeys = queryConfigJson.searchKeys,
          columns = queryConfigJson.columns;
      return _react.default.createElement(_modal.default, {
        title: "".concat(title, "\u67E5\u8BE2"),
        popup: true,
        visible: modalVisible,
        onClose: function onClose() {
          return _this4.clear();
        },
        animationType: "slide-up",
        style: {
          height: '100%'
        },
        bodyStyle: {
          display: 'flex',
          flexDirection: 'column',
          height: 'calc(100% - 39px)'
        }
      }, _react.default.createElement(_searchBar.default, {
        placeholder: "\u6839\u636E\u5173\u952E\u5B57\u67E5\u8BE2",
        onSubmit: function onSubmit(val) {
          _this4.state.pageNo = 1;
          _this4.state.pageSize = 20;
          _this4.state.tableData = [];

          _this4.search(val);
        }
      }), _react.default.createElement("div", {
        id: "scrollableDiv",
        style: {
          paddingTop: 0,
          flex: 1,
          height: '100%',
          overflow: 'auto',
          backgroundColor: 'white'
        }
      }, _react.default.createElement(_index.default, {
        dataLength: tableData.length // This is important field to render the next data
        ,
        next: function next() {
          _this4.state.pageNo += 1;

          _this4.search();
        },
        loader: _react.default.createElement("h4", {
          style: {
            textAlign: 'center'
          }
        }, "\u52A0\u8F7D\u4E2D..."),
        hasMore: pageSize * pageNo < totalCount,
        scrollableTarget: "scrollableDiv",
        endMessage: _react.default.createElement("div", {
          style: {
            textAlign: 'center'
          }
        }, _react.default.createElement("b", null, loading ? _react.default.createElement("div", {
          style: {
            textAlign: 'center'
          }
        }, "\u52A0\u8F7D\u4E2D...") : _react.default.createElement("div", {
          style: {
            textAlign: 'center'
          }
        }, "\u5DF2\u52A0\u8F7D\u5168\u90E8"))) // below props only if you need pull down functionality
        ,
        refreshFunction: function refreshFunction() {
          _this4.state.pageSize = 20;
          _this4.state.pageNo = 1;
          _this4.state.tableData = [];

          _this4.search();
        },
        pullDownToRefresh: true,
        pullDownToRefreshContent: _react.default.createElement("h3", {
          style: {
            textAlign: 'center'
          }
        }, "\u2193 \u4E0B\u62C9\u5237\u65B0"),
        releaseToRefreshContent: _react.default.createElement("div", {
          style: {
            textAlign: 'center'
          }
        }, "\u52A0\u8F7D\u4E2D...")
      }, tableData.map(function (item, inx) {
        var briefs = [];
        var mainColumn = columns[0];

        for (var i = 1; i < columns.length; i += 1) {
          var column = columns[i];
          briefs.push(_react.default.createElement(_list.default.Item.Brief, {
            key: column.key
          }, column.title, ": ", item[column.dataIndex]));
        }

        return _react.default.createElement(_list.default.Item, {
          key: inx,
          onClick: function onClick() {
            onChange(item[idKey], item);

            _this4.clear();
          }
        }, mainColumn.title, ": ", item[mainColumn.dataIndex], briefs);
      }))), _react.default.createElement(_button.default, {
        type: "warning",
        onClick: function onClick() {
          return _this4.clear();
        }
      }, "\u5173\u95ED"));
    }
  }, {
    key: "renderFormControl",
    value: function renderFormControl() {
      var _this5 = this;

      var _this$props2 = this.props,
          name = _this$props2.name,
          formData = _this$props2.formData,
          disabled = _this$props2.disabled,
          visibleField = _this$props2.visibleField;
      var modalVisible = this.state.modalVisible;
      var formOptions = this.getFormOptions();

      if (formData != null && visibleField != null) {
        formOptions.value = formData[visibleField];
      }

      var options = {};

      if (formOptions.readOnly !== true && !disabled && !formOptions.disabled) {
        options.onClick = function () {
          _this5.open();
        };
      }

      if (formOptions.disabled === true) {
        options.disabled = formOptions.disabled;
      }

      return _react.default.createElement("div", null, _react.default.createElement(_list.default.Item, _extends({
        arrow: "horizontal",
        extra: formOptions.value
      }, options), name), modalVisible ? this.renderModal() : '');
    }
  }]);

  return SearchPickerControl;
}(_FormControl2.default);

function mapStateToProps(state) {
  var page = state.page;
  return {
    page: page
  };
}

var _default = (0, _dva.connect)(mapStateToProps)(SearchPickerControl);

exports.default = _default;

function SearchPickerControlProperties(controlId, bindedFieldOptions) {
  return [{
    key: 'id',
    title: '控件ID',
    value: controlId,
    type: 'text',
    disabled: true,
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'bindField',
    title: '绑定字段',
    value: '',
    type: 'select',
    options: bindedFieldOptions,
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'visibleField',
    title: '显示字段',
    value: '',
    type: 'select',
    options: bindedFieldOptions,
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'name',
    title: '名称',
    value: '查询框',
    type: 'text',
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'queryConfig',
    title: '查询配置',
    value: '',
    type: 'code',
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'isEnabled',
    title: '是否可用',
    value: '',
    type: 'code',
    layout: {
      labelCol: {
        span: -1
      },
      wrapperCol: {
        span: 24
      }
    }
  }, {
    key: 'isVisible',
    title: '是否可见',
    value: '',
    type: 'code',
    layout: {
      labelCol: {
        span: -1
      },
      wrapperCol: {
        span: 24
      }
    }
  }, {
    key: 'isRequired',
    title: '是否必填',
    value: '0',
    type: 'select',
    options: [{
      value: '0',
      label: '否'
    }, {
      value: '1',
      label: '是'
    }],
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'onChangeEvent',
    title: '值改变事件',
    value: '',
    type: 'code',
    layout: {
      labelCol: {
        span: -1
      },
      wrapperCol: {
        span: 24
      }
    }
  }];
}