"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UploadTableControlProperties = UploadTableControlProperties;
exports.default = void 0;

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.object.set-prototype-of");

require("antd-mobile/es/modal/style");

var _modal = _interopRequireDefault(require("antd-mobile/es/modal"));

require("antd-mobile/es/swipe-action/style");

var _swipeAction = _interopRequireDefault(require("antd-mobile/es/swipe-action"));

require("antd-mobile/es/list/style");

var _list = _interopRequireDefault(require("antd-mobile/es/list"));

require("antd-mobile/es/button/style");

var _button = _interopRequireDefault(require("antd-mobile/es/button"));

require("core-js/modules/es6.function.name");

require("antd-mobile/es/toast/style");

var _toast = _interopRequireDefault(require("antd-mobile/es/toast"));

require("core-js/modules/es6.regexp.search");

var _react = _interopRequireDefault(require("react"));

var _fetch = _interopRequireDefault(require("dva/fetch"));

var _moment = _interopRequireDefault(require("moment"));

var _Control2 = _interopRequireDefault(require("../Control"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var antdMobile = require('antd-mobile');

var UploadTableControl =
/*#__PURE__*/
function (_Control) {
  _inherits(UploadTableControl, _Control);

  function UploadTableControl(props, context) {
    var _this;

    _classCallCheck(this, UploadTableControl);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(UploadTableControl).call(this, props, context));
    _this.fileRef = _react.default.createRef();
    _this.state = {
      type: 'uploadTable',
      tableData: [],
      imgViewVisible: false,
      selectedFileId: ''
    };
    return _this;
  }

  _createClass(UploadTableControl, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.search();
    }
  }, {
    key: "loadConfigJson",
    value: function loadConfigJson(fieldId) {
      var _this$props = this.props,
          formData = _this$props.formData,
          config = _this$props.config;

      if (config != null && config != '') {
        var event = new Function('formData', 'fileId', 'AntdMobile', "return ".concat(config)).bind(this);
        this.configJson = event(formData, fieldId, antdMobile);
      }

      return this.configJson;
    }
  }, {
    key: "search",
    value: function search() {
      var _this$props2 = this.props,
          formData = _this$props2.formData,
          pageId = _this$props2.pageId,
          config = _this$props2.config,
          dispatch = _this$props2.dispatch,
          designmode = _this$props2.designmode;

      if (designmode == 'true') {
        return;
      }

      this.loadConfigJson('');

      if (this.configJson == null) {
        message.error('附件表格未填写配置', 2);
        return;
      }

      var searchUrl = this.configJson.searchUrl;
      dispatch({
        type: 'page/searchUploadFileList',
        payload: {
          pageId: pageId,
          url: searchUrl,
          id: formData.f_id
        }
      });
    }
  }, {
    key: "del",
    value: function del(fileId) {
      var _this$props3 = this.props,
          formData = _this$props3.formData,
          pageId = _this$props3.pageId,
          config = _this$props3.config,
          dispatch = _this$props3.dispatch,
          designmode = _this$props3.designmode;

      if (designmode == 'true') {
        return;
      }

      this.loadConfigJson(fileId);

      if (this.configJson == null) {
        _toast.default.fail('附件表格未填写配置', 2);

        return;
      }

      var _this$configJson = this.configJson,
          deleteUrl = _this$configJson.deleteUrl,
          searchUrl = _this$configJson.searchUrl;

      if (deleteUrl == null || searchUrl == null) {
        _toast.default.fail('配置不完全', 2);

        return;
      }

      dispatch({
        type: 'page/deleteUploadFile',
        payload: {
          pageId: pageId,
          url: deleteUrl,
          searchUrl: searchUrl,
          id: formData.f_id,
          fileId: fileId
        }
      });
    }
  }, {
    key: "handleUpload",
    value: function handleUpload(files) {
      var _this2 = this;

      if (files != null && files.length > 0) {
        if (this.configJson == null) {
          _toast.default.fail('附件未配置', 2);
        } else {
          var uploadUrl = this.configJson.uploadUrl;
          var fd = new FormData();

          for (var i = 0; i < files.length; i += 1) {
            var file = files[i];
            fd.append('file', file, file.name);
          }

          (0, _fetch.default)(uploadUrl, {
            method: 'POST',
            body: fd // headers: {
            //   'Content-Type': 'multipart/form-data',
            // },

          }).then(function (response) {
            if (response.ok) {
              var responseJson = response.json();

              if (responseJson.returncode == '50000') {
                _toast.default.fail('上传失败', 2);

                return;
              }

              _toast.default.success('上传成功');

              _this2.search();
            } else {
              _toast.default.fail('上传失败', 2);
            }
          });
        }
      } // const status = info.file.status;
      // if (status !== 'uploading') {
      //   // console.log(info.file, info.fileList);
      // }
      // if (status === 'done') {
      //   if (info.file.response.returncode == '50000') {
      //     message.error(`${info.file.name} 文件上传失败.`);
      //     return;
      //   }
      //   message.success(`${info.file.name} 文件上传成功.`);
      //   this.search();
      //   if (this.props.saveImg != null) {
      //     const imgid = info.fileList[0].response[0];
      //     this.props.saveImg(imgid);
      //   }
      // } else if (status === 'error') {
      //   message.error(`${info.file.name} 文件上传失败.`);
      // }

    }
  }, {
    key: "getSwipteButtons",
    value: function getSwipteButtons(file) {
      var _this3 = this;

      this.loadConfigJson(file.id);
      var swipeButtons = [];

      if (this.configJson) {
        var buttons = this.configJson.swipeButtons;

        var _loop = function _loop(i) {
          var button = buttons[i];
          var title = button.title,
              _onPress = button.onPress;
          swipeButtons.push({
            text: title,
            onPress: function onPress() {
              if (_onPress) {
                _onPress(file);
              }
            },
            style: {
              backgroundColor: '#108ee9',
              color: 'white'
            }
          });
        };

        for (var i = 0; buttons != null && i < buttons.length; i += 1) {
          _loop(i);
        }
      }

      swipeButtons.push({
        text: '删　除',
        onPress: function onPress() {
          return _this3.del(file.id);
        },
        style: {
          backgroundColor: '#F4333C',
          color: 'white'
        }
      });
      return swipeButtons;
    }
  }, {
    key: "renderControl",
    value: function renderControl() {
      var _this4 = this;

      var _this$state = this.state,
          selectedFileId = _this$state.selectedFileId,
          imgViewVisible = _this$state.imgViewVisible;
      var fileList = this.props.fileList;
      var imgUrlJson = this.loadConfigJson(selectedFileId);
      var imgUrl = imgUrlJson == null ? '' : imgUrlJson.downloadUrl;
      console.log(imgUrl);
      return _react.default.createElement("div", {
        style: {
          minHeight: '50px'
        }
      }, _react.default.createElement("input", {
        type: "file",
        multiple: "multiple",
        ref: this.fileRef,
        style: {
          display: 'none'
        },
        onChange: function onChange(e) {
          _this4.handleUpload(e.target.files);
        }
      }), _react.default.createElement(_button.default, {
        type: "primary",
        className: "needsclick",
        onClick: function onClick() {
          _this4.fileRef.current.click();
        }
      }, "\u4E0A\u4F20\u9644\u4EF6"), _react.default.createElement(_list.default, null, fileList.map(function (file) {
        _this4.loadConfigJson(file.id);

        var downloadUrl = _this4.configJson.downloadUrl;
        var listOptions = {};

        if (file.filename.indexOf('.jpg') != -1 || file.filename.indexOf('.png') != -1 || file.filename.indexOf('.jepg') != -1) {
          listOptions.thumb = downloadUrl;

          listOptions.onClick = function () {
            _this4.setState({
              imgViewVisible: true,
              selectedFileId: file.id
            });
          };
        } else {
          listOptions.thumb = '/images/file.png';
        }

        return _react.default.createElement(_swipeAction.default, {
          key: file.id,
          style: {
            backgroundColor: 'gray'
          },
          autoClose: true,
          right: _this4.getSwipteButtons(file)
        }, _react.default.createElement(_list.default.Item, listOptions, file.filename, _react.default.createElement(_list.default.Item.Brief, null, (0, _moment.default)(file.updatedate).format('YYYY-MM-DD HH:mm:ss'))));
      })), _react.default.createElement(_modal.default, {
        visible: imgViewVisible,
        style: {
          width: "".concat(window.innerWidth, "px"),
          height: "".concat(window.innerHeight, "px")
        }
      }, _react.default.createElement("img", {
        src: imgUrl,
        style: {
          width: "".concat(window.innerWidth, "px")
        },
        onClick: function onClick() {
          _this4.setState({
            imgViewVisible: false,
            selectedFileId: ''
          });
        }
      })));
    }
  }]);

  return UploadTableControl;
}(_Control2.default);

exports.default = UploadTableControl;

function UploadTableControlProperties(controlId) {
  return [{
    key: 'id',
    title: '控件ID',
    value: controlId,
    type: 'text',
    disabled: true,
    layout: {
      labelCol: {
        span: 6
      },
      wrapperCol: {
        span: 18
      }
    }
  }, {
    key: 'config',
    title: '配置',
    value: '',
    type: 'code',
    layout: {
      labelCol: {
        span: -1
      },
      wrapperCol: {
        span: 24
      }
    }
  }];
}