"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.post = post;
exports.get = get;

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

require("regenerator-runtime/runtime");

require("core-js/modules/es6.promise");

var _request = _interopRequireDefault(require("./request"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function post(_x, _x2) {
  return _post.apply(this, arguments);
}

function _post() {
  _post = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee(params, headerParams) {
    var token, localDev, url, headers;
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            token = sessionStorage.getItem('token');
            localDev = sessionStorage.getItem('LOCAL_DEV');

            if (token == null) {
              token = 'undefined';
            }

            url = params.url; // if (url.indexOf('bpm') == -1) {

            if (url.indexOf('?') == -1) {
              url += "?token=".concat(token);
            } else {
              url += "&token=".concat(token);
            } // }


            headers = {};

            if (headerParams != null && typeof headerParams != 'function') {
              headers = _objectSpread({}, headerParams);
            }

            if (localDev != null) {
              headers['LOCAL_DEV'] = "".concat(localDev);
            } else {
              headers['LOCAL_DEV'] = '0';
            }

            delete params.url;
            return _context.abrupt("return", (0, _request.default)(url, {
              method: 'post',
              body: JSON.stringify(params.params),
              headers: headers
            }));

          case 10:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));
  return _post.apply(this, arguments);
}

function get(_x3, _x4) {
  return _get.apply(this, arguments);
}

function _get() {
  _get = _asyncToGenerator(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee2(params, headerParams) {
    var localDev, url, headers;
    return _regenerator.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            localDev = sessionStorage.getItem('LOCAL_DEV');
            url = params.url;
            delete params.url;
            headers = {};

            if (headerParams != null && typeof headerParams != 'function') {
              headers = _objectSpread({}, headerParams);
            }

            if (localDev != null) {
              headers['LOCAL_DEV'] = "".concat(localDev);
            } else {
              headers['LOCAL_DEV'] = '0';
            }

            return _context2.abrupt("return", (0, _request.default)(url, {
              method: 'get',
              headers: headers // body: JSON.stringify(params.params),

            }));

          case 7:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));
  return _get.apply(this, arguments);
}